
const

no_of_keywords = 60;
keyword_size = 14;

keyword_identifier_table : array [ 1..no_of_keywords ] of String[ keyword_size ] = (
  'AND', 'ARRAY', 'AS', 'ASM', 'BEGIN', 'CASE', 'CLASS', 'CONST', 'CONSTRUCTOR', 
  'DESTRUCTOR', 'DIV', 'DO', 'DOWNTO', 'ELSE', 'END', 'EXCEPT', 'EXPORTS', 
  'FILE', 'FINALLY', 'FOR', 'FUNCTION', 'GOTO', 'IF', 'IMPLEMENTATION', 'IN', 
  'INHERITED', 'INITIALIZATION', 'INLINE', 'INTERFACE', 'IS', 'LABEL', 'LIBRARY', 
  'MOD', 'NIL', 'NOT', 'OBJECT', 'OF', 'OR', 'PACKED', 'PROCEDURE', 'PROGRAM', 
  'PROPERTY', 'RAISE', 'RECORD', 'REPEAT', 'SET', 'SHL', 'SHR', 'STRING', 'THEN', 
  'TO', 'TRY', 'TYPE', 'UNIT', 'UNTIL', 'USES', 'VAR', 'WHILE', 'WITH', 'XOR'
);

keyword_token_table : array [ 1..no_of_keywords ] of Integer = (
  _AND_, _ARRAY_, _AS_, _ASM_, _BEGIN_, _CASE_, _CLASS_, _CONST_, 
  _CONSTRUCTOR_, _DESTRUCTOR_, _DIV_, _DO_, _DOWNTO_, _ELSE_, _END_, _EXCEPT_, 
  _EXPORTS_, _FILE_, _FINALLY_, _FOR_, _FUNCTION_, _GOTO_, _IF_, 
  _IMPLEMENTATION_, _IN_, _INHERITED_, _INITIALIZATION_, _INLINE_, _INTERFACE_, 
  _IS_, _LABEL_, _LIBRARY_, _MOD_, _NIL_, _NOT_, _OBJECT_, _OF_, _OR_, 
  _PACKED_, _PROCEDURE_, _PROGRAM_, _PROPERTY_, _RAISE_, _RECORD_, _REPEAT_, 
  _SET_, _SHL_, _SHR_, _STRING_, _THEN_, _TO_, _TRY_, _TYPE_, _UNIT_, _UNTIL_, 
  _USES_, _VAR_, _WHILE_, _WITH_, _XOR_
);


(* KWTBL keyword table lookup procedure V1.0 6-7-91 AG *)

function kwlookup( kw : String; var code : Integer ) : Boolean;
  (* checks whether kw is in the keyword table; if so, returns the
     corresponding integer code *)
  var m, n, k : integer;
  begin
    (* binary search: *)
    m := 1; n := no_of_keywords;
    while m<=n do
      begin
        k := m+(n-m) div 2;
        if kw=keyword_identifier_table[k] then
          begin
            kwlookup := true;
            code := keyword_token_table[k];
            exit
          end
        else if kw>keyword_identifier_table[k] then
          m := k+1
        else
          n := k-1
      end;
    kwlookup := false
  end(*kwlookup*);

