
const

no_of_keywords = 28;
keyword_size = 9;

keyword_identifier_table : array [ 1..no_of_keywords ] of String[ keyword_size ] = (
  'ABSOLUTE', 'ABSTRACT', 'ASSEMBLER', 'AT', 'CDECL', 'DEFAULT', 'DYNAMIC', 
  'EXPORT', 'EXTERNAL', 'FAR', 'FORWARD', 'INDEX', 'INTERRUPT', 'MESSAGE', 
  'NAME', 'NEAR', 'NODEFAULT', 'ON', 'OVERRIDE', 'PRIVATE', 'PROTECTED', 
  'PUBLIC', 'PUBLISHED', 'READ', 'RESIDENT', 'STORED', 'VIRTUAL', 'WRITE'
);

keyword_token_table : array [ 1..no_of_keywords ] of Integer = (
  _ABSOLUTE_, _ABSTRACT_, _ASSEMBLER_, _AT_, _CDECL_, _DEFAULT_, _DYNAMIC_, 
  _EXPORT_, _EXTERNAL_, _FAR_, _FORWARD_, _INDEX_, _INTERRUPT_, _MESSAGE_, 
  _NAME_, _NEAR_, _NODEFAULT_, _ON_, _OVERRIDE_, _PRIVATE_, _PROTECTED_, 
  _PUBLIC_, _PUBLISHED_, _READ_, _RESIDENT_, _STORED_, _VIRTUAL_, _WRITE_
);


(* KWTBL keyword table lookup procedure V1.0 6-7-91 AG *)

function kwlookup( kw : String; var code : Integer ) : Boolean;
  (* checks whether kw is in the keyword table; if so, returns the
     corresponding integer code *)
  var m, n, k : integer;
  begin
    (* binary search: *)
    m := 1; n := no_of_keywords;
    while m<=n do
      begin
        k := m+(n-m) div 2;
        if kw=keyword_identifier_table[k] then
          begin
            kwlookup := true;
            code := keyword_token_table[k];
            exit
          end
        else if kw>keyword_identifier_table[k] then
          m := k+1
        else
          n := k-1
      end;
    kwlookup := false
  end(*kwlookup*);

